require 'yaml'

def yamlname_attack
  'data/' + toeuc(@context.target) + '_attack.yml'
end

def attack_init
  fname = yamlname_attack
  if (File.exist?(fname))
    print "load attack stat file #{fname}\n"
    File.open(fname) do |ifile|
      @attack_stat = YAML.load(ifile)
    end
  else
    @attack_stat = Hash.new
  end
end

def attack_desc
  "attack>(target): 򤷤ޤ"
end

def attack(msg)
  if (mirror_now && @mirror_result && @mirror_result.key?(@context.nick) &&
      @mirror_result[@context.nick] != 'ϵ')
    return "ʤϿϵǤϤޤ"
  end

  if (msg == @context.nick)
    return "ʬ򽱷Ǥޤ"
  end

  if (mirror_now && @mirror_result && @mirror_result.key?(msg) &&
      @mirror_result[msg] == 'ϵ')
    return "ϵ򽱷⤹뤳ȤϤǤޤ"
  end
 
  if (@attack_last == @context.nick && @attacked_last == msg)
    return "᥼å"
  end
  @attack_last = @context.nick
  @attacked_last = msg

  if (!@attack_mutex)
    @attack_mutex = Mutex.new
  end

  Thread.new do
    print "create attack thraed...\n"
    w = @conf['attack_wait'].to_i
    if (w == 0)
      w = 3
    end
    sleep(w)

    if ((@defenced && @defenced == msg) ||
          (@mirror_result && @mirror_result[msg] == 'ϥॹʹ'))
      notice("ϵԤʤ褦ϵϽ˼ԤΤ")
    else
      notice("ī#{msg}̵ĤʻѤȯ줿")

      @attack_mutex.synchronize do
        @attack_stat[msg] = @attack_stat[msg].to_i + 1
        fname = yamlname_attack
        File.open(fname, 'w') do |ofile|
          YAML.dump(@attack_stat, ofile)
        end
      end
    end
  end

  "#{msg}̿"
end

