require 'yaml'

def yamlname_epi
  'data/' + toeuc(@context.target) + '_epi.yml'
end

def epi_init
  if (!@conf['epi_reminder'] || @conf['epi_reminder'] != '1')
    return
  end

  if (@epi_thread)
    return
  end

  fname = yamlname_epi
  if (File.exist?(fname))
    print "load epi data file #{fname}\n"
    File.open(fname) do |ifile|
      @epi_data = YAML.load(ifile)
    end
  else
    @epi_data = Hash.new
  end

  @epi_thread = Thread.new do
    print "create epi thraed...\n"

    countries = [
      #    'ܹ',
      #    '¹',
      'ù',
      'Ĺ',
    ]
    urls = {
      #    'ܹ' => 'http://ninjinia.x0.com/wolf/',
      #    '¹' => 'http://ninjinium.x0.com/wolfb/',
      'ù' => 'http://ninjinel.x0.com/wolfc/',
      'Ĺ' => 'http://ninjin.80code.com/wolfd/',
    }

    while (true)
      countries.each do |country|
        url = urls[country]

        top = http_get(url)

        top.split(/\n/).reverse.each do |line|
          if (line =~ /^<tr><td><a href="index.rb\?vid=(\d+)[^>]+>([^ ]+)[^<]+<\/a> <strong>[^<]+<\/strong><\/td><td>Ԥꤷޤ<\/td><\/tr>/)
            vid = $1
            name = $2
            if (!@epi_data.key?(name))
              @epi_data[name] = true

              fname = yamlname_epi
              File.open(fname, 'w') do |ofile|
                YAML.dump(@epi_data, ofile)
              end

              vil = http_get("#{url}index.rb?vid=#{vid}&mes=all")
              vil =~ />(\d+)<\/a> <span class="time">ԥ/
              date = $1
              win =
                if (vil =~ /⤦ϵ񹳤Ǥۤ¼ͤϻĤäƤʤġ/)
                  "ϵ"
                else
                  "¼;"
                end

              notice("#{name}¼λޤ#{date}ܺǽǡ#{win}")
            end
          end
        end
      end

      sleep(30*60)
    end
  end
end

def epi_desc
  "epi>: λ¼ưΤޤ"
end

def epi(msg)
  if (msg == 'kill_thread')
    if (@epi_thread)
      @epi_thread.kill
      @epi_thread = nil
      return "λ¼Τߤޤ"
    end
    return "λ¼ΤưƤޤ"
  end

  return "ưѤΥޥɤǤ"
end
