def mura_init
  if (!@conf['mura_reminder'] || @conf['mura_reminder'] != '1')
    return
  end

  if (@mura_thread)
    return
  end

  @mura_thread = Thread.new do
    print "create mura thraed...\n"

    mura('')

    spans = {
#      'ܹ' => 5,
#      '¹' => 7,
      'ù' => 7,
      'Ź' => 5,
      'ƹ' => 5,
    }

    cnt = 0

    while (true)
      sleep(60)

      # 3 hour period
      cnt += 1
      if (cnt == 180)
        cnt = 0
        print mura('').join(', ') + "\n"
      end

      if (!@mura_update)
        next
      end

      @mura_update.each do |country, data|
        hour = data[0]
        min = data[1]
        vid = data[2]

        now = Time.now
        diff = ((hour-now.hour)*60+(min-now.min))*60-now.sec
        prev = @conf['mura_before'].to_i
        if (prev == 0)
          prev = 300
        end
        if (diff >= prev && diff < prev+60)
          span = spans[country]
          hour += span
          if (hour > 23)
            hour -= 24
          end
          minstr = if (min < 10)
                     "0#{min}"
                   else
                     min.to_s
                   end

          notice("#{country}#{hour}#{minstr}ʬ#{vid}¼Ǥ뤫⤷ޤ")
          #mura('')
        end
      end
    end
  end
end

def mura_desc
  "mura>: ȯ¼Τޤ"
end

def mura(msg)
  if (msg == 'kill_thread')
    if (@mura_thread)
      @mura_thread.kill
      @mura_thread = nil
      return "¼Τߤޤ"
    end
    return "¼ΤưƤޤ"
  end

  if (!@mura_update)
    @mura_update = Hash.new
  end

  countries = [
#    'ܹ',
#    '¹',
    'ù',
    'Ź',
    'ƹ',
  ]
  urls = {
#    'ܹ' => 'http://ninjinia.x0.com/wolf/',
#    '¹' => 'http://ninjinium.x0.com/wolfb/',
    'ù' => 'http://ninjinel.x0.com/wolfc/',
    'Ź' => 'http://ninjin001.x0.com/wolfe/',
    'ƹ' => 'http://ninjin002.x0.com/wolff/',
  }

  ret = Array.new

  countries.each do |country|
    url = urls[country]

    top = http_get(url)

    top.split(/\n/).each do |line|
      if (line =~ /^<table class="list"><tr><td><a href="index\.rb\?vid=(\d+)[^>]+>([^\<]+)<\/a> <strong>([^<]+)/)
        vid = $1.to_i
        name = $2
        update = $3
        update =~ /^([^\s]+) (\d+) (\d+)ʬ/
        hour = $2.to_i
        min = $3.to_i
        if ($1 == '')
          hour += 12
        end

        ok = false
        i = 0
        while (!ok)
          vid += 1

          i += 1
          if (i > 5)
            break
          end

          next_vil = http_get("#{url}index.rb?vid=#{vid}")

          if (next_vil =~ /<p>¼Ĥޤ<\/p>/m)
            ok = true
          else
            next_vil =~ /<strong>\d+\/\d+ ([^\s]+) (\d+) (\d+)ʬ˹<\/strong>/m
            hour = $2.to_i
            min = $3.to_i
            if ($1 == '')
              hour += 12
            end

            if (hour == 0)
              min = if (min == 0) then 30 else 0 end
            end

            sleep(3)
          end
        end

        if (ok)
          minstr = if (min < 10)
                     "0#{min}"
                   else
                     min.to_s
                   end
          ret.push("#{country}: #{hour}#{minstr}ʬ #{vid}¼")

          @mura_update[country] = [hour, min, vid]
        else
          ret.push("#{country}: ʤǤ")
        end

        break
      end
    end
  end

  ret
end
