require 'yaml'

def yamlname_vote
  'data/' + toeuc(@context.target) + '_vote.yml'
end

def vote_init
  fname = yamlname_vote
  if (File.exist?(fname))
    print "load vote stat file #{fname}\n"
    File.open(fname) do |ifile|
      @vote_stat = YAML.load(ifile)
    end
  else
    @vote_stat = Hash.new
    @vote_stat['all'] = Hash.new
    @vote_stat['num'] = Hash.new
  end
end

def vote_desc
  "vote>(target): ɼ򤷤ޤ"
end

def vote(msg)
  if (msg == @context.nick)
    return "ʬˤɼǤޤ"
  end

  if (!@vote_mutex)
    @vote_mutex = Mutex.new
  end

  not_in_vote = true
  @vote_mutex.synchronize do
    not_in_vote = !@voted
  end

  if (not_in_vote)
    @voted = Hash.new

    Thread.new do
      print "create vote thraed...\n"
      w = @conf['vote_wait'].to_i
      if (w == 0)
        w = 60
      end
      sleep(w)

      notice("ϹƤ")
      votes = Hash.new
      max = 0
      @vote_mutex.synchronize do
        @voted.each do |k, v|
          notice("#{v[0]}  #{v[1]} ɼ")

          votes[v[1]] = if (votes.key?(v[1]))
                       votes[v[1]] + 1
                     else
                       1
                     end
          if (votes[v[1]] > max)
            max = votes[v[1]]
          end

          @vote_stat['all'][v[1]] = @vote_stat['all'][v[1]].to_i + 1
        end

        picked = votes.select { |k, v| v == max }
        result = picked[rand(picked.size)][0]

        notice("̡#{result} 跺줿")

        @vote_stat['num'][result] = @vote_stat['num'][result].to_i + 1

        fname = yamlname_vote
        File.open(fname, 'w') do |ofile|
          YAML.dump(@vote_stat, ofile)
        end

        @voted = nil
      end
    end
  end

  @vote_mutex.synchronize do
    @voted[@context.user] = [@context.nick, msg]
  end

  "#{msg} ɼޤ"
end
